// Definicija klase krugova (Krug).

#ifndef _krug2_h_
#define _krug2_h_

#include "figura.h"

static const Real PI = 3.14159265359;

class Krug : public Figura {
  Real ro;                                 // Poluprecnik.
public:
  Krug (Real rr=1, const Tacka &tt=ORG)    // Konstruktor.
    : Figura (tt) { ro = rr; }
  Figura *kopija () const                  // Stvaranje kopije.
    { return new Krug (*this); }
  Real O () const { return 2  * ro * PI; } // Obim.
  Real P () const { return ro * ro * PI; } // Povrsina.
  Real d () const { return 2  * ro; }      // Precnik.
  Real r () const { return ro; }           // Poluprecnik upisanog kruga.
  Real R () const { return ro; }           // Poluprecnik opisanog kruga.
private:
  void citaj (istream &dd) ;               // Citanje.
  void pisi  (ostream &dd) const ;         // Pisanje.
} ;

#endif
