// Definicija klase polinoma (Poli).

#include <iostream.h>

class Poli {
  int n; double *a;          // Red polinoma i pokazivac na koeficijente.
  typedef const Poli &Uko;   // Upucivac na nepromenljivi objekat.
  void kopiraj (const double *a, int n);   // Kopiranje u tekuci objekat.
  void brisi () { delete[] a; a=0; n=-1; } // Praznjenje polinoma.
public:                                             // Konstruktori:
  Poli () { a = 0; n = -1; }                        //   - prazan polinom
  Poli (const double *a, int n) { kopiraj (a, n); } //   - od niza
  Poli (Uko p) { kopiraj (p.a, p.n); }              //   - od polinoma
  ~Poli () { brisi (); }                            // Destruktor.
  Poli & operator= (Uko p) {                        // Dodela vrednosti.
    if (&p != this) { brisi(); kopiraj(p.a, p.n); }
    return *this;
  }
  void niz (double *a, int &n) const;       // Smestanje polinoma u niz.
  int operator+ () const { return n; }      // Red polinoma.
  double & operator[] (int ind) const;      // Dohvatanje koeficijenta.
  double operator() (double x) const;                       // p(x)
  friend Poli operator+ (Uko p1, Uko p2) ;                  // p1 +  p2
  friend Poli operator- (Uko p1, Uko p2) ;                  // p1 -  p2
  friend Poli operator* (Uko p1, Uko p2) ;                  // p1 *  p2
  Poli & operator+= (Uko p2) { return *this = *this + p2; } // p1 += p2
  Poli & operator-= (Uko p2) { return *this = *this - p2; } // p1 -= p2
  Poli & operator*= (Uko p2) { return *this = *this * p2; } // p1 *= p2
  friend istream & operator>> (istream &d, Poli &p) ; // Citanje polinoma
  friend ostream & operator<< (ostream &d, Uko p) ;   // Pisanje polinoma
private:
  enum Greska { G_MEM=1, G_RED, G_IND };   // Sifre gresaka.
  void greska (Greska g) const;            // Obrada greske.
};
